/* ************************************* */
/* CluePushButton (Windows 95)           */
/* Created by T. Kormann - UNSA 1996     */
/* Improved by P. Le Hegaret - UNSA 1996 */
/* Improved by V Mallet FOUFFA           */
/* Date : Thu Dec 19 17:20:49 MET 1996   */
/*                                       */
/* Feel free to use, copy, modify        */
/* comments :                            */
/*    tkormann@clio.unice.fr             */
/*    plehegar@clio.unice.fr             */
/* ************************************* */

#include <Xm/Xm.h>
#include <Xm/PushB.h>
#include <Xm/MainW.h>
#include <Xm/Label.h>
#include <Xm/Frame.h>

#include "cluepushbutton.h"

static void pop_it_now (XtPointer client_data, XtIntervalId *id);
static void pop_clue (Widget w, XtPointer client_data, XmPushButtonCallbackStruct *cbs);
static void kill_clue (Widget w, XtPointer client_data, XmPushButtonCallbackStruct *cbs);

static Widget clue, labelclue;
static XtIntervalId id_clue;
static ClueStruct clue_info;

void Initialisation_clue (Widget main) {
  clue = XmCreateFrame(main, "clue", NULL, 0);
  labelclue = XmCreateLabel(clue, "labelclue", NULL, 0);
  XtManageChild(labelclue);
}


Widget XmCreateCluePushButton(Widget parent, char *name, char *l, ArgList arglist, Cardinal argcount) {
  Widget button;
  button = XmCreatePushButton(parent, name, arglist, argcount);
  XtAddCallback(button, XmNarmCallback, (XtCallbackProc) kill_clue, NULL);
  XtAddEventHandler(button, EnterWindowMask, False , (XtEventHandler) pop_clue, l);
  XtAddEventHandler(button, LeaveWindowMask, False , (XtEventHandler) kill_clue, NULL);
  return button;
}

static void pop_clue (Widget w, XtPointer client_data, XmPushButtonCallbackStruct *cbs) {
  XtAppContext app = XtWidgetToApplicationContext(w);
  clue_info.label = (char *) client_data;
  clue_info.w = w;
  id_clue = XtAppAddTimeOut(app, DELAI, pop_it_now, (XtPointer) &clue_info);
}

static void kill_clue (Widget w, XtPointer client_data, XmPushButtonCallbackStruct *cbs) {
  XtRemoveTimeOut(id_clue);
  XtUnmanageChild(clue);
}


static void pop_it_now (XtPointer client_data, XtIntervalId *id) {
  Position x, y;
  Dimension height;
  ClueStruct *c = (ClueStruct *) client_data; 
  XmString s = XmStringCreateLocalized(c->label);
  Widget w = c->w;

  /* fix current label clue */
  XtVaSetValues(labelclue, XmNlabelString, s, NULL);
  
  XmStringFree(s); /* ViM 970325: bein Thierry faut pas oublier ca! */

  XtVaGetValues(w,
		XtNheight, &height,
		XmNx, &x,
		XmNy, &y,
		NULL);

  XtVaSetValues(clue,
		XmNx, x+24,
		XmNy, y+height+35,
		NULL );

  XtManageChild(clue);
}



