/*
 * config.H
 *
 * Handles the configuration object which is able 
 * to be written to and read from a file.
 *
 * Vincent Mallet 1997, 1999
 */

// $Id: config.H,v 1.2 1999/04/20 21:18:15 vmallet Exp $

/* ViMmail - a small mail reader
 * Copyright (C) 1997, 1999 Vincent Mallet - vmallet@enst.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __ZLF_CONFIG__
#define __ZLF_CONFIG__

#ifndef TRUE   
#define TRUE 1
#endif
               
#ifndef FALSE
#define FALSE 0
#endif


class Config { 
public:

  char *log_name;
  char *home_path;
  char *spool_path;
  char *initrc_file;
  char *mbox_file;
  char *mail_file;


  int   check_delay;
  
  int   toolbar_visible;
  int   ask_before_quit;
  int   popup_on_startup;
  int   show_last_message;
  int   tab_expand;
  
  char *text_color_string;
  char *quote_color_string;
  char *header_color_string;
  char *header_high_color_string;


  Config(void);
    
  int getconfig(void);
  void set_default(void);
  void save_config(void);

private:
  int read_configfile(char *filename);
  int write_configfile(char *filename);
  char * capitalize(char *s);


}; // class Config


#endif /* #ifndef __ZLF_CONFIG__ */




