/*
 * eyes.C
 *
 * Little green eyes. Not finished.
 *
 * Vincent Mallet 1997, 1999
 */

// $Id: eyes.C,v 1.2 1999/04/20 21:52:00 vmallet Exp $

/* ViMmail - a small mail reader
 * Copyright (C) 1997, 1999 Vincent Mallet - vmallet@enst.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif 

#include <Xm/Xm.h>
#include <Xm/PushB.h>

#include "pushbuttons.h"

#include "vimmail.H"
#include "application.H"
#include "interface.H"

#include "eyes.H"

#include "Pixmaps/deveyes.xpm"
#include "Pixmaps/deveyes1.xpm"
#include "Pixmaps/deveyes2.xpm"
#include "Pixmaps/deveyes3.xpm"
#include "Pixmaps/deveyes4.xpm"
#include "Pixmaps/deveyes5.xpm"


// Initialize the eyes
void Eyes:: make(Widget parent)
{
  widget = XmCreatePushButton(parent, "Eyes", NULL, 0);
  CreatePixmapButton(widget, devileyes_xpm, devileyes_xpm, NULL);
  XtManageChild(widget);

  state = 0;
}

// Start the eyes (install the timer handler)
void Eyes:: start_eyes(void)
{
  XtAppAddTimeOut(vimmail.interface.context, 1000, timeout_handler1, (XtPointer) this);
}

// First timer: delay between two animations
void Eyes:: timeout_handler1(XtPointer client_data, XtIntervalId *Id)
{
  Eyes *mythis = (Eyes *) client_data;

  Id = Id;

  XtAppAddTimeOut(vimmail.interface.context, 4000, timeout_handler2, (XtPointer) mythis);
}

// Second time: eyes animation
void Eyes:: timeout_handler2(XtPointer client_data, XtIntervalId *Id)
{
  Eyes *mythis = (Eyes *) client_data;
  mythis->state++;

  Id = Id;

  switch(mythis->state) {
  case 1:
    CreatePixmapButton(mythis->widget, devileyes1_xpm, devileyes_xpm, NULL);
    break;
  case 2:
    CreatePixmapButton(mythis->widget, devileyes2_xpm, devileyes_xpm, NULL);
    break;
  case 3:
    CreatePixmapButton(mythis->widget, devileyes3_xpm, devileyes_xpm, NULL);
    break;
  case 4:
    CreatePixmapButton(mythis->widget, devileyes4_xpm, devileyes_xpm, NULL);
    break;
  case 5:
    CreatePixmapButton(mythis->widget, devileyes5_xpm, devileyes_xpm, NULL);
    break;
  case 6:
    CreatePixmapButton(mythis->widget, devileyes4_xpm, devileyes_xpm, NULL);
    break;
  case 7:
    CreatePixmapButton(mythis->widget, devileyes3_xpm, devileyes_xpm, NULL);
    break;
  case 8:
    CreatePixmapButton(mythis->widget, devileyes2_xpm, devileyes_xpm, NULL);
    break;
  case 9:
    CreatePixmapButton(mythis->widget, devileyes1_xpm, devileyes_xpm, NULL);
    break;
  case 10:
    CreatePixmapButton(mythis->widget, devileyes_xpm, devileyes_xpm, NULL);
    break;
  default:
    mythis->state = 0;
    XtAppAddTimeOut(vimmail.interface.context, 2250, timeout_handler1, (XtPointer) mythis);
    return;
  }

  XtAppAddTimeOut(vimmail.interface.context, 90, timeout_handler2, (XtPointer) mythis);
}




