/*
 * filelist.C
 *
 * The list that contains mail file names.
 * Subclass of the AbsList abstract list class.
 *
 * Vincent Mallet 1997, 1999
 */

// $Id: filelist.C,v 1.2 1999/04/20 21:55:07 vmallet Exp $

/* ViMmail - a small mail reader
 * Copyright (C) 1997, 1999 Vincent Mallet - vmallet@enst.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <Xm/Xm.h>
#include <Xm/List.h>

#include <stdio.h>

#include "vimmail.H"
#include "application.H"
#include "filelist.H"


// Initialize this list
void FileList:: make(Widget parent)
{
  widget = XmCreateScrolledList(parent, "FileScrolledList", NULL, 0);

  XtAddCallback(widget, XmNbrowseSelectionCallback, list_handler, (XtPointer) this);

  XtManageChild(widget);
}

// callback activated when an entry in the list gets selected
void FileList:: list_handler(Widget w, XtPointer client_data, XtPointer cbs)
{
  w = w; // warnings...
  client_data = client_data;

  vimmail.set_active_message_file(((XmListCallbackStruct *)cbs)->item_position - 1);
}


