/*
 * message_file.H
 *
 * Deals with a standard unix mail file, such as /var/spool/mail/...
 *
 * Vincent Mallet, 1997, 1999
 */

// $Id: message_file.H,v 1.2 1999/04/20 21:43:22 vmallet Exp $

/* ViMmail - a small mail reader
 * Copyright (C) 1997, 1999 Vincent Mallet - vmallet@enst.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#ifndef ___H_MESSAGE_FILE__
#define ___H_MESSAGE_FILE__

#include <stdio.h>
#include <unistd.h>
#include <sys/stat.h>

class Message_File;

#include "message.H"
#include "vimmail.H"



class Message_File 
{
public:
  FILE *file;
  char *file_name;

  int   nb_messages;
  long  size;

  Message * messages[VM_MAXMESSAGES_PER_FILE];


  Message_File(char *filename);
  
  ~Message_File();

  int    need_a_rescan(void);
  int    rescan_messages(void);
  void   show_headers(void);
  void   prompt(void);
  char * toString(void);


  // cursor movements
  int    empty(void);
  void   start(void);
  void   end(void);
  int    off(void);
  void   forth(void);
  void   set_current(int index);

  int    cursor(void);

  // access
  Message & item(void);
  Message & item(int index);


  // private
  int open_file(void);
  void close_file(void);

private:
  int _cursor;

  void clear_messages(void);
};


#endif // ___H_MESSAGE_FILE__






